---@diagnostic disable: lowercase-global, undefined-global

VERSION = 0.01
AUTHOR = "martblek (martblek@gmail.com)"


vb = renoise.ViewBuilder()
vbs = vb.views
dialog = nil
rns = nil
rnt = renoise.tool()
ra = renoise.app()

IMAGE = nil

Notifiers = {}
function Notifiers:add(observable, callable)
  if not observable:has_notifier(callable) then
    observable:add_notifier(callable)
  end
end


function Notifiers:remove(observable, callable)
  if observable:has_notifier(callable) then
    observable:remove_notifier(callable)
  end
end


Bitmap = require('src/bmp')
require('src/render')
require('src/gui')

renoise.tool():add_menu_entry{
  name = "Sample Editor: Img2Wave",
  invoke = function()
    prepare_for_start()
  end
}


renoise.tool():add_keybinding{
  name="Global:Tools: Img2Wave",
  invoke=function()
    prepare_for_start()
  end
}


_AUTO_RELOAD_DEBUG = function()
end


function app_idle()
  if not dialog.visible then
    Notifiers:remove(rnt.app_idle_observable, app_idle)
  end
end


function key_handler(dialog, key)
  return key
end


function prepare_for_start()

  if(dialog and dialog.visible) then
    dialog:show()
    return
  end

  dialog = renoise.app():show_custom_dialog('~ Img2Wave by m@rtblek ~', make_gui, key_handler)
  Notifiers:add(renoise.tool().app_idle_observable, app_idle)
end