
function mapFromTo(x,a,b,c,d)
    -- A,B input, C, D output
    local y = (x - a) / (b - a) * (d - c) + c
    return y
end

function LoadImage()
    local filename = renoise.app():prompt_for_filename_to_read({'*.BMP', '*.bmp'}, 'Load BMP Image')
    if not filename then return end
    local bmp, err = Bitmap.from_file(filename)
    if not bmp then
        renoise.app():show_error(err)
        return
    end
    return bmp
end

function Render()

    local pi = math.pi
    local sin = math.sin
    
    local samplerate = 44100
    local length = math.floor(IMAGE.width)

    local instrument = renoise.song().selected_instrument
    local nr_samples = #instrument.samples
    local new_sample
    if nr_samples == 0 then
        new_sample = instrument:insert_sample_at(1)
    else
        new_sample = renoise.song().selected_sample
    end

    local new_buffer = new_sample.sample_buffer

    new_buffer:create_sample_data(44100, 16, 1, length)
    new_buffer:prepare_sample_data_changes()

    local value
    local prec = vbs.precision.value
    print(IMAGE.width, IMAGE.height)
    for x=1, IMAGE.width do
        for y = 1, IMAGE.height do
            local r, g, b, a = IMAGE:get_pixel(x - 1, y - 1)
            if r < prec and g < prec and b < prec then
                value = mapFromTo(y, 0, IMAGE.height, 1, -1)
                break
            else
                value = 0
            end
        end
        new_buffer:set_sample_data(1, x, value)
    end
    new_buffer:finalize_sample_data_changes()
end